// -*- coding:euc-jp -*-
#include "wimexim.h"
#include "lib/log.h"
#include "lib/ut.h"
#include "so/wimeapi.h"
#include <string.h>
#include <stdlib.h>

extern Display* Disp;

/*
  XIM_PREEDIT_STARTΤʸϤ줿Ȥˤ褦Ȼפä
  XIM_PREEDIT_STARTäXIM_PREEDIT_START_REPLYɬפ롣
  ߤι¤Ǥϥ٥Ȥ뤿˥ᥤ롼פʤФʤʤ
  ΤᤳδؿXIM_PREEDIT_START뤳Ȥˤ롣
  ʸ³Ϥ硢XIM_PREEDIT_DONE,XIM_PREEDIT_START³뤳Ȥˤ롣
  ѴϾ֤ˤʤäƤ櫓ǡҤȤĤäꤷʤǤϤϤ᤿XIM_PREEDIT_START,ϤäXIM_PREEDIT_DONEˤϤƤ饤٥Ȥä쥹ݥ󥹤ʤ뤫
  ⤽⥫֤ʤɤξǤʤΤǡ䥦ɥŬڤʾɽ뤳ȤǤʤon-the-spotФϿͤʤȤˤ롣
*/
static int open_ime(CallbackParam* p,bool st)
{
    int code,sync;
    if(st){
	code = XIM_PREEDIT_START;
	sync = XIM_PREEDIT_START_REPLY;
    }else{
	code = XIM_PREEDIT_DONE;
	sync = 0;
    }
    WimeEnableIme(p->Ic->WimeCxn,st);
    SendW(p->Client,code,p->Pkt->imid,p->Pkt->icid);
    return sync;
}

//winΰֳ¦Υɥ֤
Window app_window(Window win)
{
    Window root, parent=win;
    Status st=1;
    do{
	Window* ch;
	unsigned nch;
	win = parent;
	st = XQueryTree(Disp,win,&root,&parent,&ch,&nch);
	//DEBUGLOG(CH_XIM,"0:%d %x %x %x\n",st,win,parent,root);
	XFree(ch);
    }while(st && parent!=root);
    return st ? win : 0;
}

//winΰֳ¦Υɥΰ֤礭֤NULLǤ֤ʤ
bool app_geo(Window win,int* x,int* y,int* w,int* h)
{
    bool st = false;
    win = app_window(win);
    if(!win){
	DEBUGLOG(CH_XIM,"invalid window\n");
    }else{
	XWindowAttributes at;
	Window ch;
	int dum;
	if(x == NULL)
	    x = &dum;
	if(y == NULL)
	    y = &dum;
	if(XGetWindowAttributes(Disp,win,&at) &&
	   XTranslateCoordinates(Disp,win,XDefaultRootWindow(Disp),0,0,x,y,&ch)){
	    if(w)
		*w = at.width;
	    if(h)
		*h = at.height;
	    st = true;
	}else{
	    DEBUGLOG(CH_XIM,"cannot get client window position\n");
	}
    }
    return st;
}

static void draw(CallbackParam* cbp)
{
    int ctlen=0;
    char* ct=NULL;

    DEBUGLOG(CH_XIM,"pos:%d delta:%d cl:%d cl-len:%d len:%d [%U]\n",cbp->si->CursorPos,cbp->si->DeltaStart,cbp->si->TargetClause,cbp->si->TargetClLen,cbp->si->Length,cbp->u8);

    if(cbp->u8!=NULL){
	char* ej = U8ToEj(NULL,cbp->u8);
	ct = EucjpToCtext(ej);
	ctlen = strlen(ct);
	free(ej);
    }

    DEBUGLOG(CH_XIM,"ctlen %d preedit-len %d\n",ctlen,cbp->Ic->PreeditLen);
    int d1size = sizeof(XimPreeditDraw1)+ctlen+Pad(2+ctlen);
    int pktsize = d1size+sizeof(XimPreeditDraw2)+cbp->si->Length*MEMBERSIZE(XimPreeditDraw2,feedback[0]);
    XimPreeditDraw1* d1 = malloc(pktsize);
    XimPreeditDraw2* d2 = (XimPreeditDraw2*)((char*)d1 + d1size);
    d1->imid = cbp->Pkt->imid;
    d1->icid = cbp->Pkt->icid;
    d1->caret = cbp->si->CursorPos;
    d1->chg_first = 0;

    if(*ct == 0){
	//ԽХåեˤ
	if(cbp->Ic->PreeditLen > 0){
	    d1->chg_length = cbp->Ic->PreeditLen;
	    d1->status = PREEDIT_DRAW_NO_STR|PREEDIT_DRAW_NO_FB;
	    DEBUGLOG(CH_XIM,"clear buf:len=%d st=%d\n",d1->chg_length,d1->status);
	    SendN(cbp->Client,XIM_PREEDIT_DRAW,d1,pktsize);
	}
    }else{
	//ХåեΤ֤
	d1->chg_length = cbp->Ic->PreeditLen;
	d1->status = 0;
	memcpy(d1->str,ct,d1->str_len=ctlen);
    
	d2->feedback_len = sizeof(d2->feedback[0])*cbp->si->Length;
	for(int x=0; x<cbp->si->Length; ++x) //Τ˥饤
	    d2->feedback[x]=XIMUnderline;
	if(cbp->si->TargetClause != -1){ //ʸ᤬Фʬȿž
	    for(int x=0; x<cbp->si->TargetClLen; ++x)
		d2->feedback[cbp->si->TargetClause+x] = XIMReverse;
	}
	SendN(cbp->Client,XIM_PREEDIT_DRAW,d1,pktsize);

	cbp->Ic->PreeditLen = cbp->si->Length;
	DEBUGLOG(CH_XIM,"replace buf:prelen=%d\n",cbp->Ic->PreeditLen);
    }
    free(ct);
    free(d1);

    //ץꥱβ˸䥦ɥ֤
    int x=0,y=0,h=0;
    app_geo(cbp->Ic->Attrs.ClientWindow,&x,&y,NULL,&h);
    WimeSetCandWin(cbp->Ic->WimeCxn,WIME_POS_POINT,x,y+h);
}

static int done_preedit(CallbackParam* p,const char* partial_comp_str,const WimeCompStrInfo* si)
{
    if(p->Ic->PreeditLen > 0){
	/* ooǤԽʸõʤФcommitŤϤƤޤ
	   leafpadǤʤ*/
	int bufsize = sizeof(XimPreeditDraw1)+Pad(2)+sizeof(XimPreeditDraw2);
	char buf[bufsize];
	XimPreeditDraw1* d1 = memset(buf,0,bufsize);
	d1->imid = p->Pkt->imid;
	d1->icid = p->Pkt->icid;
	d1->chg_length = p->Ic->PreeditLen;
	d1->status = PREEDIT_DRAW_NO_STR|PREEDIT_DRAW_NO_FB;
	DEBUGLOG(CH_XIM,"clear buf:caret %d first %d prelen %d\n",d1->caret,d1->chg_first,d1->chg_length);
	SendN(p->Client,XIM_PREEDIT_DRAW,d1,bufsize);
    }
    if(partial_comp_str == NULL){
	//
	p->Ic->PreeditLen = 0;
	SendW(p->Client,XIM_PREEDIT_DONE,p->Pkt->imid,p->Pkt->icid);
	SendW(p->Client,XIM_PREEDIT_START,p->Pkt->imid,p->Pkt->icid);
	return XIM_PREEDIT_START_REPLY;
    }

    //pʬǡѴʸ󤬤ޤĤäƤ롣
    SendW(p->Client,XIM_SYNC_REPLY,p->Pkt->imid,p->Pkt->icid); //XIM_PREEDIT_DRAWФ
    CallbackParam cbp={.Ic=p->Ic, .Client=p->Client, .Pkt=p->Pkt, .u8=partial_comp_str, .si=si};
    DEBUGLOG(CH_XIM,"partical composition:%U\n",partial_comp_str);
    draw(&cbp);
    return 0;
}

static bool reject_key(int wimecxn)
{
    /*
      ԽΤȤXIM_FORWARD_EVENT֤bad protocolˤʤäƤޤ
      gtkΤȤ 򤱤뤿ˡԽʸ󤬤ʤȤ֤
    */
    char* cmp = WimeGetCompStr(wimecxn,NULL);
    bool st = (cmp==NULL);
    free(cmp);
    return st;
}

static void init(CallbackParam* cbp)
{
    WimeShowToolbar(cbp->Ic->WimeCxn,true,false);

    /*!!!
      ֤Ǥʤ򺸾ˤƤ
      礭ϤΤޤޤˤƤҤäȤ鸵礭Ƹ䥦ɥ
      ɽʤ⤷ʤ
    */
    WimeMoveShadowWin(cbp->Ic->WimeCxn,0,0,-1,-1);
}

ConvCallbackFuncs ConvFuncOnTheSpot = {
    .OpenIme =		open_ime,
    .Done =		done_preedit,
    .Draw =		draw,
    .RejectKey =	reject_key,
    .Cleanup =		ConvDoNothing,
    .SetSpotLoc =	ConvDoNothing,
    .Init =		init,
    .TargetWindow =	(typeof(ConvFuncOnTheSpot.TargetWindow))ConvDoNothing,
    .MoveWime =		ConvDoNothing,
};

//(C) 2009 thomas
